 
cls
use temp_covid_countries_scm, clear


global datefirst = "15dec2020"
global datelast = "15may2021"  
global initialcontrol = "15dec2020"
global finalcontrol = "14feb2021"
global treatment = "15feb2021"

sum date if tin($initialcontrol,$initialcontrol)
global t1 = r(mean)
global t1_5 = $t1+5
global t1_10 = $t1+10
global t1_15 = $t1+15
global t1_20 = $t1+20
global t1_25 = $t1+25
global t1_30 = $t1+30
global t1_35 = $t1+35
global t1_40 = $t1+40
global t1_45 = $t1+45
global t1_50 = $t1+50
global t1_55 = $t1+55
global t1_60 = $t1+60
global t1_65 = $t1+65
global t1_70 = $t1+70
global t1_75 = $t1+75

sum date if tin($finalcontrol,$finalcontrol)
global t2 = r(mean)
sum date if tin($treatment,$treatment)
global t3 = r(mean)

keep if tin($initialcontrol,$datelast)




set seed 2803


cls

global nreps = 500

local irep = 1

forvalues irep = 1(1)$nreps {
	

	use temp_covid_countries_scm, clear
	encode country, gen(countryno) 

	xtset countryno date
    
	/// list country casesvar if tin($treatment,$treatment)
	
	*added by G
	qui egen tag = tag(countryno) if leader==0
	qui gen shuffle = .
	qui gen sampled = .

	qui replace shuffle = runiform() if leader==0
	sort tag shuffle
    
	* the 20 tagged values are at the end; we select 3 of them 
	qui replace sampled = inrange(_n,_N-2,_N) if leader==0
	
    * spread selection to each panel 
    qui bysort countryno (sampled) : replace sampled = sampled[_N]

	list country if sampled==1 & tin($treatment,$treatment)

    levelsof countryno if sampled 
	egen aux_sampled_id = min(countryno) if sampled==1 
	replace aux_sampled_id = 0 if countryno~=aux_sampled_id & sampled==1

*	list country if sampled==0 & tin(15feb2021,15feb2021)
	
    
	*added by G take an average of the 4 selected countries 
	egen casesvar2 = mean(casesvar) if sampled==1, by(date)
	egen deathsvar2 = mean(deathsvar) if sampled==1, by(date)
	egen stringency2 = mean(stringencyvar) if sampled==1, by(date)
	egen vax2 = mean(vax) if sampled==1, by(date)
	egen mobvar2 = mean(mobvar) if sampled==1, by(date)

	replace mobvar = mobvar2 if countryno==aux_sampled_id
	replace stringencyvar = stringency2 if countryno==aux_sampled_id
	replace casesvar = casesvar2 if countryno==aux_sampled_id
	replace deathsvar = deathsvar2 if countryno==aux_sampled_id
	replace vax = vax2 if countryno== aux_sampled_id
	drop if aux_sampled_id == 0




	/// list country casesvar countryno aux_sampled_id if tin($treatment,$treatment)



	
	summarize countryno if countryno == aux_sampled_id
	global code = r(mean)


		synth2 deathsvar ///
	deathsvar($t1(1)$t2) ///
	stringencyvar($t1(1)$t2) ///
	mobvar($t1(1)$t2) ///
	deathsvar($t1) ///
	deathsvar($t1_5) ///
	deathsvar($t1_10) ///
	deathsvar($t1_15) ///
	deathsvar($t1_20) ///
	deathsvar($t1_25) ///
	deathsvar($t1_30) ///
	deathsvar($t1_35) ///
	deathsvar($t1_40) ///
	deathsvar($t1_45) ///
	deathsvar($t1_50) ///
	deathsvar($t1_55) ///
	deathsvar($t2) ///
	stringencyvar($t1) ///
	stringencyvar($t1_5) ///
	stringencyvar($t1_10) ///
	stringencyvar($t1_15) ///
	stringencyvar($t1_20) ///
	stringencyvar($t1_25) ///
	stringencyvar($t1_30) ///
	stringencyvar($t1_35) ///
	stringencyvar($t1_40) ///
	stringencyvar($t1_45) ///
	stringencyvar($t1_50) ///
	stringencyvar($t1_55) ///
	stringencyvar($t2) ///
	mobvar($t1) ///
	mobvar($t1_5) ///
	mobvar($t1_10) ///
	mobvar($t1_15) ///
	mobvar($t1_20) ///
	mobvar($t1_25) ///
	mobvar($t1_30) ///
	mobvar($t1_35) ///
	mobvar($t1_40) ///
	mobvar($t1_45) ///
	mobvar($t1_50) ///
	mobvar($t1_55) ///
	mobvar($t2), ///
	trunit($code) trperiod($t3) ///
	keep(syntcont_`irep', replace) 


	preserve
	use syntcont_`irep'.dta, clear
	decode _Co_Number, gen(country) 
	save syntcont_`irep', replace
	restore


	gen newleader=0
	di `irep'
	replace newleader=1 if countryno == aux_sampled_id

	merge m:m country using syntcont_`irep'.dta, nogen 

	

	gen synth_weight = round(1000*_W_Weight)

	list country synth_weight newleader if tin($datelast,$datelast)	

	replace synth_weight = 100 if newleader==1

	collapse casesvar deathsvar vax stringencyvar mobvar [fw=synth_weight], by(newleader date)
	xtset newleader date
	label var newleader "New Leader"
	label var casesvar "New Cases Per Million"
	label var deathsvar "New Deaths Per Million"
	label var stringencyvar "Oxford Stringency Index"
	label var vax "Vaccines Given (% of pop.)"
	label var mobvar "Google Mobility"

	

	list casesvar deathsvar vax mobvar newleader if tin($datelast,$datelast)


	preserve
	rename casesvar casesvar`irep'
	rename deathsvar deathsvar`irep'
	rename vax vax`irep'
	rename stringencyvar stringencyvar`irep'
	rename mobvar mobvar`irep'

	egen mcasesvar`irep' = mean(casesvar`irep'), by(date)
	gen gapcasesvar`irep' = 2*(casesvar`irep'-mcasesvar`irep')

	egen mvax`irep' = mean(vax`irep'), by(date)
	gen gapvax`irep' = 2*(vax`irep'-mvax`irep')

	egen mstringencyvar`irep' = mean(stringencyvar`irep'), by(date)
	gen gapstringencyvar`irep' = 2*(stringencyvar`irep'-mstringencyvar`irep')

	egen mdeathsvar`irep' = mean(deathsvar`irep'), by(date)
	gen gapdeathsvar`irep' = 2*(deathsvar`irep'-mdeathsvar`irep')

    egen mmobvar`irep' = mean(mobvar`irep'), by(date)
	gen gapmobvar`irep' = 2*(mobvar`irep'-mmobvar`irep')

	gen leader`irep' = newleader
	save formerge_`irep', replace
	restore
	





	

	format stringencyvar %5.0f

	

	//*** Plot 2: TIME-SERIES ***
	
/*
	xtline vax if tin($datefirst,$datelast), ///
	ylabel(, labsize(medium) angle(horizontal)) ///
	ttick(1dec2020 1jan2021 1feb2021 1mar2021 1apr2021) ///
	tlabel(15dec2020 "Dec." 15jan2021 "Jan." 15feb2021 "Feb." 15mar2021 "Mar.", notick format(%tdm) labsize(medium)) ///
	ytitle(, size(medium)) ///
	xtitle(, size(medium)) ///
	xlabel(,  labsize(medium)) ///
	overlay xtitle("") ///
	plot1(lwidth(medthick)) ///
	plot2(lwidth(thick)) ///
	tline($t1 $t2, lcol(black) lpatter(shortdash)) ///
	legend(order(2 "Treated Country" 1 "Synthetic Country") size(small) cols(1) position(0) bplacement(nwest)) ///
	graphregion(fcolor(white)) name(vaxx, replace) nodraw

	xtline deathsvar if tin($datefirst,$datelast), ///
	overlay xtitle("") legend(off) graphregion(fcolor(white)) ///
	ylabel(, labsize(medium)  format(%9.0f) angle(horizontal)) ///
	ttick(1dec2020 1jan2021 1feb2021 1mar2021 1apr2021) ///
	tlabel(15dec2020 "Dec." 15jan2021 "Jan." 15feb2021 "Feb." 15mar2021 "Mar.", notick format(%tdm) labsize(medium)) ///
	ytitle(, size(medium)) ///
	xtitle(, size(medium)) ///
	plot1(lwidth(medthick)) ///
	plot2(lwidth(thick)) ///
	tline($t1 $t2, lcol(black) lpatter(shortdash)) ///
	xlabel(,  labsize(medium)) ///
	name(deathsv, replace) nodraw

	xtline mobvar if tin($datefirst,$datelast), ///
	ylabel(, labsize(medium) angle(horizontal)) ///
	ttick(1dec2020 1jan2021 1feb2021 1mar2021 1apr2021) ///
	tlabel(15dec2020 "Dec." 15jan2021 "Jan." 15feb2021 "Feb." 15mar2021 "Mar.", notick format(%tdm) labsize(medium)) ///
	ytitle(, size(medium)) ///
	xtitle(, size(medium)) ///
	plot1(lwidth(medthick)) ///
	plot2(lwidth(thick)) ///
	tline($t1 $t2, lcol(black) lpatter(shortdash)) ///
	xlabel(,  labsize(medium)) ///
	overlay xtitle("") legend(off) graphregion(fcolor(white)) ///
	name(mobvarv, replace) nodraw

	xtline stringencyvar if tin($datefirst,$datelast), ///
	ylabel(, labsize(medium) angle(horizontal)) ///
	ysc(r(60 80)) ///
	ylabel(60(5)80) ///
	ttick(1dec2020 1jan2021 1feb2021 1mar2021 1apr2021) ///
	tlabel(15dec2020 "Dec." 15jan2021 "Jan." 15feb2021 "Feb." 15mar2021 "Mar.", notick format(%tdm) labsize(medium)) ///
	ytitle(, size(medium)) ///
	xtitle(, size(medium)) ///
	plot1(lwidth(medthick)) ///
	plot2(lwidth(thick)) ///
	tline($t1 $t2, lcol(black) lpatter(shortdash)) ///
	xlabel(,  labsize(medium)) ///
	overlay xtitle("") legend(off) graphregion(fcolor(white)) name(stringencyv, replace) nodraw
	

	graph combine vaxx deathsv stringencyv mobvarv, rows(2) graphregion(fcolor(white))  name(KK_`irep', replace)
	
*/	


}







clear
clear all 
clear matrix
set maxvar 45000

use formerge_1, clear

quietly{
*foreach l of local levels {
forvalues irep = 1(1)$nreps {

	merge 1:1 date newleader using formerge_`irep', force nogen
	erase formerge_`irep'.dta
	erase syntcont_`irep'.dta
}
}





save temp_scm_repetitions, replace

use temp_scm_repetitions, clear


set obs 1000
gen n = _n
gen gapvar_c = .
gen gapvar_m = .
gen gapvar_d = .


quietly{

forvalues irep=1/$nreps {
sum gapcasesvar`irep' if tin($treatment,$datelast) & newleader==1
replace gapvar_c = `r(mean)' if n==`irep'
sum gapmobvar`irep' if tin($treatment,$datelast) & newleader==1
replace gapvar_m = `r(mean)' if n==`irep'
sum gapdeathsvar`irep' if tin($treatment,$datelast) & newleader==1
replace gapvar_d = `r(mean)' if n==`irep'
}

}

label var gapvar_c "COVID-19 Cases Gap - CI Synth. Control"
label var gapvar_m "Google Mobility Gap - CI Synth. Control"
label var gapvar_d "COVID-19 Deaths Gap - CI Synth. Control"


pctile pct_m = gapvar_m, nq(20) genp(percent_m)
list percent_m pct_m in 1/19

pctile pct_d = gapvar_d, nq(20) genp(percent_d)
list percent_d pct_d in 1/19





use IFDP_note_for_charttwo_final, clear

tabulate leader if tin($treatment,$datelast), summarize(deathsvar)
tabulate leader if tin($treatment,$datelast), summarize(mobvar)
tabulate leader if tin($treatment,$datelast), summarize(vax)

//tabulate leader if tin($treatment,10may2021), summarize(deathsvar)
//tabulate leader if tin($treatment,10may2021), summarize(mobvar)
//tabulate leader if tin($treatment,10may2021), summarize(vax)

//tabulate leader if tin($treatment,$datelast), summarize(mobvar)
//tabulate leader if tin($treatment,10may2021), summarize(mobvar)
